image: registry.gitlab.com/ratio-case-os/docker/rust-ci:base

stages:
  - test
  - deploy

python-build:
  image: registry.gitlab.com/ratio-case-os/docker/rust-ci:cross
  stage: test
  script:
    - just build-python
  artifacts:
    paths:
      - target/wheels/
    expire_in: 30 days

rust-lint:
  stage: test
  script:
    - just lint-lib

python-lint:
  stage: test
  script:
    - just lint-python

rust-test:
  stage: test
  script:
    - just test-lib-coverage
  coverage: '/^\s*(\d+(?:\.\d+)?%)\s*coverage.*$/'
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: target/tarpaulin/cobertura.xml

rust-flamegraph:
  stage: test
  script:
    - just flamegraph
  artifacts:
    paths:
      - target/flames/

python-test:
  stage: test
  script:
    - just test-python

rust-deploy:
  stage: deploy
  only:
    refs:
      - main
  needs:
    - rust-test
  script:
    - just publish-lib
  allow_failure: true

# Publish using an OIDC token.
# See https://docs.pypi.org/trusted-publishers/using-a-publisher/#gitlab-cicd
python-deploy:
  stage: deploy
  image: python:3-slim
  dependencies:
    - python-build
  only:
    refs:
      - main
  id_tokens:
    PYPI_ID_TOKEN:
      # Use "testpypi" if uploading to TestPyPI
      aud: pypi
  script:
    # Install dependencies
    - apt update && apt install -y curl jq
    - python -m pip install -U twine id

    # Retrieve the OIDC token from GitLab CI/CD, and exchange it for a PyPI API token
    - oidc_token=$(python -m id PYPI)
    # Replace "https://pypi.org/*" with "https://test.pypi.org/*" if uploading to TestPyPI
    - resp=$(curl -X POST https://pypi.org/_/oidc/mint-token -d "{\"token\":\"${oidc_token}\"}")
    - api_token=$(jq --raw-output '.token' <<< "${resp}")

    # Upload to PyPI authenticating via the newly-minted token
    # Add "--repository testpypi" if uploading to TestPyPI
    - twine upload -u __token__ -p "${api_token}" target/wheels/*
  allow_failure: true
